From d9c933ea29ca2c3f356deee426ca740703e49228 Mon Sep 17 00:00:00 2001
From: Petri Hintukainen <phintuka@users.sourceforge.net>
Date: Tue, 4 Feb 2014 10:43:02 +0200
Subject: [PATCH 11/17] bluray: Handle overlay even if no data is returned
 (still image or no background video).

Simplify.
Remove incorrect end of title log message.
---
 modules/access/bluray.c | 21 +++++++--------------
 1 file changed, 7 insertions(+), 14 deletions(-)

diff --git a/modules/access/bluray.c b/modules/access/bluray.c
index bc531ab..00ba8a9 100644
--- a/modules/access/bluray.c
+++ b/modules/access/bluray.c
@@ -1666,10 +1666,6 @@ static int blurayDemux(demux_t *p_demux)
 
         nread = bd_read(p_sys->bluray, p_block->p_buffer,
                         NB_TS_PACKETS * BD_TS_PACKET_SIZE);
-        if (nread < 0) {
-            block_Release(p_block);
-            return nread;
-        }
     } else {
         nread = bd_read_ext(p_sys->bluray, p_block->p_buffer,
                             NB_TS_PACKETS * BD_TS_PACKET_SIZE, &e);
@@ -1677,16 +1673,6 @@ static int blurayDemux(demux_t *p_demux)
             blurayHandleEvent(p_demux, &e);
             bd_get_event(p_demux->p_sys->bluray, &e);
         }
-        if (nread < 0) {
-            block_Release(p_block);
-            return -1;
-        }
-        if (nread == 0) {
-            if (e.event == BD_EVENT_NONE)
-                msg_Info(p_demux, "We reached the end of a title");
-            block_Release(p_block);
-            return 1;
-        }
     }
 
     if (p_sys->current_overlay != -1) {
@@ -1705,6 +1691,13 @@ static int blurayDemux(demux_t *p_demux)
         }
     }
 
+    if (nread <= 0) {
+        block_Release(p_block);
+        if (nread < 0)
+            return -1;
+        return 1;
+    }
+
     p_block->i_buffer = nread;
 
     stream_DemuxSend(p_sys->p_parser, p_block);
-- 
1.8.3.2

